QT       += core gui widgets

OUTSBDR = a429
NAME = a429electroprogonapp

include(../pri/common.pri)
include(../pri/app.pri)
include(../pri/deploy.pri)

#debug {
#    # Конфигурация debug? Это qmake не волнует! Он всё равно добавит флаги из release! Ату его!
#    CONFIG -= release # Эта строчка уберёт ключ -O2

#    QMAKE_CXXFLAGS += -O0 #Или QMAKE_CXXFLAGS_DEBUG
#    QMAKE_CFLAGS += -O0   #Или QMAKE_CFLAGS_DEBUG
#}

#release {
#    # Эти строчки уберут ключ -O2 -------------------------
#    QMAKE_CXXFLAGS_RELEASE -= -O2
#    QMAKE_CFLAGS_RELEASE -= -O2

#    QMAKE_CXXFLAGS += -O3  #Или QMAKE_CXXFLAGS_RELEASE
#    QMAKE_CFLAGS += -O3    #Или QMAKE_CFLAGS_RELEASE
#}

QMAKE_CXXFLAGS += "-fno-sized-deallocation"

INCLUDEPATH += source \
    source/tools

SOURCES += \
    source/entity/onedeviceelectroprogontask.cpp \
    source/main.cpp \
    source/tools/a429_library_adapter.cpp \
    source/tools/channelfinder.cpp \
    source/tools/globaltools.cpp \
    source/tools/logger.cpp \
    source/tools/memloader.cpp \
    source/wgt/dialoghtml.cpp \
    source/wgt/mainwindow.cpp \
    source/wgt/listnetworkdialog.cpp \
    source/wgt/dialog_extaddresseditor.cpp \
    source/wgt/widgetdevice.cpp

HEADERS += \
    source/entity/onedeviceelectroprogontask.h \
    source/interface/iwidgetdevice.h \
    source/wgt/dialoghtml.h \
    source/wgt/mainwindow.h \
    source/tools/a429_library_adapter.h \
    source/tools/channelfinder.h \
    source/tools/globaltools.h \
    source/tools/logger.h \
    source/tools/memloader.h \
    source/wgt/widgetdevice.h \
    source/wgt/listnetworkdialog.h \
    source/wgt/dialog_extaddresseditor.h \
    source/version.h

RESOURCES += \
    res.qrc

FORMS += \
    source/wgt/dialoghtml.ui \
    source/wgt/mainwindow.ui \
    source/wgt/listnetworkdialog.ui \
    source/wgt/dialog_extaddresseditor.ui \
    source/wgt/widgetdevice.ui


############################
# Для параметров линковки библиотек
DEFINES += ENABLE_LINKING_FROM_SOURCES

CONFIG += NO_LIBRARIES_FOUND

############################
## подключение библиотеки, при наличии
exists(../../ExtA429Library) {
    CONFIG -= NO_LIBRARIES_FOUND
    DEFINES += HAS_EXTA429_LIBRARY
    INCLUDEPATH += ../../ExtA429Library

    win32: LIBS += -lws2_32

SOURCES += \
    ../../ExtA429Library/a429ext_eth_ioctl.c \
    ../../ExtA429Library/a429ext_library.c

HEADERS += \
    ../../ExtA429Library/a429_cmd.h \
    ../../ExtA429Library/a429ext_library.h \
    ../../ExtA429Library/a429_regs.h \
    ../../ExtA429Library/a429_common.h \
    ../../ExtA429Library/a429ext_eth_ioctl.h \
    ../../ExtA429Library/a429ext_meu_proto.h
}

############################
## подключение библиотеки, при наличии
exists(../../A429LinuxLibrary) {
    CONFIG -= NO_LIBRARIES_FOUND
    DEFINES += HAS_A429_LIBRARY

    INCLUDEPATH += ../../A429LinuxLibrary
    HEADERS += \
        ../../A429LinuxLibrary/a429_cmd.h \
        ../../A429LinuxLibrary/a429_library.h \
        ../../A429LinuxLibrary/a429_regs.h \
        ../../A429LinuxLibrary/a429_common.h

    SOURCES += \
        ../../A429LinuxLibrary/a429_library.c
}
############################

NO_LIBRARIES_FOUND {
error("Not found $$system_path($$clean_path($$_PRO_FILE_PWD_/../../)/A429LinuxLibrary) and/or $$system_path($$clean_path($$_PRO_FILE_PWD_/../../)/ExtA429Library)")
}
