#include "dialog_extaddresseditor.h"
#include "ui_dialog_extaddresseditor.h"
#include <QRegExpValidator>
#include <QRegExp>
#include <QPushButton>

Dialog_ExtAddressEditor::Dialog_ExtAddressEditor(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog_ExtAddressEditor)
{
    ui->setupUi(this);
    setResult(QDialog::Rejected);

    QString reStr = "^" + QStringList::fromStdList(std::list<QString>(4, "(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])")).join("\\.") + "$";

    auto reValidator = new QRegExpValidator(QRegExp(reStr), this);
    ui->lineEdit_ipAddress->setValidator(reValidator);

    connect(ui->lineEdit_ipAddress, &QLineEdit::textChanged, this, [=]{
        ui->buttonBox->button(QDialogButtonBox::Ok)->setEnabled(ui->lineEdit_ipAddress->hasAcceptableInput());
    });

    ui->buttonBox->button(QDialogButtonBox::Ok)->setText("OK");
    connect(ui->buttonBox, &QDialogButtonBox::accepted, this, &Dialog_ExtAddressEditor::accept);
}

Dialog_ExtAddressEditor::~Dialog_ExtAddressEditor()
{
    delete ui;
}

ExtDevice Dialog_ExtAddressEditor::getResult() const
{
    ExtDevice result;

#ifdef HAS_EXTMIL1553UD_LIBRARY
    result.channelFd.socketFD = -1;
    result.channelFd.channel = 0;
#endif

    result.ipAddress = ui->lineEdit_ipAddress->text();
    result.port = ui->spinBox_port->value();
    // result.channel = ui->spinBox_channel->value();

    return result;
}

void Dialog_ExtAddressEditor::setDevice(const ExtDevice &device)
{
    ui->lineEdit_ipAddress->setText(device.ipAddress);
    ui->spinBox_port->setValue(device.port);
}
